## API Report File for "firebase-admin.auth"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

/// <reference types="node" />

import { Agent } from 'http';

// @public
export interface ActionCodeSettings {
    android?: {
        packageName: string;
        installApp?: boolean;
        minimumVersion?: string;
    };
    dynamicLinkDomain?: string;
    handleCodeInApp?: boolean;
    iOS?: {
        bundleId: string;
    };
    url: string;
}

// @public
export interface AllowByDefault {
    disallowedRegions: string[];
}

// @public
export interface AllowByDefaultWrap {
    allowByDefault: AllowByDefault;
    // @alpha (undocumented)
    allowlistOnly?: never;
}

// @public
export interface AllowlistOnly {
    allowedRegions: string[];
}

// @public
export interface AllowlistOnlyWrap {
    // @alpha (undocumented)
    allowByDefault?: never;
    allowlistOnly: AllowlistOnly;
}

// @public
export class Auth extends BaseAuth {
    // Warning: (ae-forgotten-export) The symbol "App" needs to be exported by the entry point index.d.ts
    get app(): App;
    projectConfigManager(): ProjectConfigManager;
    tenantManager(): TenantManager;
}

// @public
export class AuthClientErrorCode {
    // (undocumented)
    static AUTH_BLOCKING_TOKEN_EXPIRED: {
        code: string;
        message: string;
    };
    // (undocumented)
    static BILLING_NOT_ENABLED: {
        code: string;
        message: string;
    };
    // (undocumented)
    static CLAIMS_TOO_LARGE: {
        code: string;
        message: string;
    };
    // (undocumented)
    static CONFIGURATION_EXISTS: {
        code: string;
        message: string;
    };
    // (undocumented)
    static CONFIGURATION_NOT_FOUND: {
        code: string;
        message: string;
    };
    // (undocumented)
    static EMAIL_ALREADY_EXISTS: {
        code: string;
        message: string;
    };
    // (undocumented)
    static EMAIL_NOT_FOUND: {
        code: string;
        message: string;
    };
    // (undocumented)
    static FORBIDDEN_CLAIM: {
        code: string;
        message: string;
    };
    // (undocumented)
    static ID_TOKEN_EXPIRED: {
        code: string;
        message: string;
    };
    // (undocumented)
    static ID_TOKEN_REVOKED: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INSUFFICIENT_PERMISSION: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INTERNAL_ERROR: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_ARGUMENT: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_CLAIMS: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_CONFIG: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_CONTINUE_URI: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_CREATION_TIME: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_CREDENTIAL: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_DISABLED_FIELD: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_DISPLAY_NAME: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_DYNAMIC_LINK_DOMAIN: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_EMAIL: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_EMAIL_VERIFIED: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_ENROLLED_FACTORS: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_ENROLLMENT_TIME: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_HASH_ALGORITHM: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_HASH_BLOCK_SIZE: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_HASH_DERIVED_KEY_LENGTH: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_HASH_KEY: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_HASH_MEMORY_COST: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_HASH_PARALLELIZATION: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_HASH_ROUNDS: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_HASH_SALT_SEPARATOR: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_ID_TOKEN: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_LAST_SIGN_IN_TIME: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_NAME: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_NEW_EMAIL: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_OAUTH_CLIENT_ID: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_OAUTH_RESPONSETYPE: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_PAGE_TOKEN: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_PASSWORD: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_PASSWORD_HASH: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_PASSWORD_SALT: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_PHONE_NUMBER: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_PHOTO_URL: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_PROJECT_ID: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_PROVIDER_DATA: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_PROVIDER_ID: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_PROVIDER_UID: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_RECAPTCHA_ACTION: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_RECAPTCHA_ENFORCEMENT_STATE: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_SESSION_COOKIE_DURATION: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_TENANT_ID: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_TENANT_TYPE: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_TESTING_PHONE_NUMBER: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_TOKENS_VALID_AFTER_TIME: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_UID: {
        code: string;
        message: string;
    };
    // (undocumented)
    static INVALID_USER_IMPORT: {
        code: string;
        message: string;
    };
    // (undocumented)
    static MAXIMUM_TEST_PHONE_NUMBER_EXCEEDED: {
        code: string;
        message: string;
    };
    // (undocumented)
    static MAXIMUM_USER_COUNT_EXCEEDED: {
        code: string;
        message: string;
    };
    // (undocumented)
    static MISMATCHING_TENANT_ID: {
        code: string;
        message: string;
    };
    // (undocumented)
    static MISSING_ANDROID_PACKAGE_NAME: {
        code: string;
        message: string;
    };
    // (undocumented)
    static MISSING_CONFIG: {
        code: string;
        message: string;
    };
    // (undocumented)
    static MISSING_CONTINUE_URI: {
        code: string;
        message: string;
    };
    // (undocumented)
    static MISSING_DISPLAY_NAME: {
        code: string;
        message: string;
    };
    // (undocumented)
    static MISSING_EMAIL: {
        code: string;
        message: string;
    };
    // (undocumented)
    static MISSING_HASH_ALGORITHM: {
        code: string;
        message: string;
    };
    // (undocumented)
    static MISSING_IOS_BUNDLE_ID: {
        code: string;
        message: string;
    };
    // (undocumented)
    static MISSING_ISSUER: {
        code: string;
        message: string;
    };
    // (undocumented)
    static MISSING_OAUTH_CLIENT_ID: {
        code: string;
        message: string;
    };
    // (undocumented)
    static MISSING_OAUTH_CLIENT_SECRET: {
        code: string;
        message: string;
    };
    // (undocumented)
    static MISSING_PROVIDER_ID: {
        code: string;
        message: string;
    };
    // (undocumented)
    static MISSING_SAML_RELYING_PARTY_CONFIG: {
        code: string;
        message: string;
    };
    // (undocumented)
    static MISSING_UID: {
        code: string;
        message: string;
    };
    // (undocumented)
    static NOT_FOUND: {
        code: string;
        message: string;
    };
    // (undocumented)
    static OPERATION_NOT_ALLOWED: {
        code: string;
        message: string;
    };
    // (undocumented)
    static PHONE_NUMBER_ALREADY_EXISTS: {
        code: string;
        message: string;
    };
    // (undocumented)
    static PROJECT_NOT_FOUND: {
        code: string;
        message: string;
    };
    // (undocumented)
    static QUOTA_EXCEEDED: {
        code: string;
        message: string;
    };
    // (undocumented)
    static RECAPTCHA_NOT_ENABLED: {
        code: string;
        message: string;
    };
    // (undocumented)
    static SECOND_FACTOR_LIMIT_EXCEEDED: {
        code: string;
        message: string;
    };
    // (undocumented)
    static SECOND_FACTOR_UID_ALREADY_EXISTS: {
        code: string;
        message: string;
    };
    // (undocumented)
    static SESSION_COOKIE_EXPIRED: {
        code: string;
        message: string;
    };
    // (undocumented)
    static SESSION_COOKIE_REVOKED: {
        code: string;
        message: string;
    };
    // (undocumented)
    static TENANT_NOT_FOUND: {
        code: string;
        message: string;
    };
    // (undocumented)
    static UID_ALREADY_EXISTS: {
        code: string;
        message: string;
    };
    // (undocumented)
    static UNAUTHORIZED_DOMAIN: {
        code: string;
        message: string;
    };
    // (undocumented)
    static UNSUPPORTED_FIRST_FACTOR: {
        code: string;
        message: string;
    };
    // (undocumented)
    static UNSUPPORTED_SECOND_FACTOR: {
        code: string;
        message: string;
    };
    // (undocumented)
    static UNSUPPORTED_TENANT_OPERATION: {
        code: string;
        message: string;
    };
    // (undocumented)
    static UNVERIFIED_EMAIL: {
        code: string;
        message: string;
    };
    // (undocumented)
    static USER_DISABLED: {
        code: string;
        message: string;
    };
    // (undocumented)
    static USER_NOT_DISABLED: {
        code: string;
        message: string;
    };
    // (undocumented)
    static USER_NOT_FOUND: {
        code: string;
        message: string;
    };
}

// @public
export type AuthFactorType = 'phone';

// @public
export type AuthProviderConfig = SAMLAuthProviderConfig | OIDCAuthProviderConfig;

// @public
export interface AuthProviderConfigFilter {
    maxResults?: number;
    pageToken?: string;
    type: 'saml' | 'oidc';
}

// @public
export abstract class BaseAuth {
    createCustomToken(uid: string, developerClaims?: object): Promise<string>;
    createProviderConfig(config: AuthProviderConfig): Promise<AuthProviderConfig>;
    createSessionCookie(idToken: string, sessionCookieOptions: SessionCookieOptions): Promise<string>;
    createUser(properties: CreateRequest): Promise<UserRecord>;
    deleteProviderConfig(providerId: string): Promise<void>;
    deleteUser(uid: string): Promise<void>;
    deleteUsers(uids: string[]): Promise<DeleteUsersResult>;
    generateEmailVerificationLink(email: string, actionCodeSettings?: ActionCodeSettings): Promise<string>;
    generatePasswordResetLink(email: string, actionCodeSettings?: ActionCodeSettings): Promise<string>;
    generateSignInWithEmailLink(email: string, actionCodeSettings: ActionCodeSettings): Promise<string>;
    generateVerifyAndChangeEmailLink(email: string, newEmail: string, actionCodeSettings?: ActionCodeSettings): Promise<string>;
    getProviderConfig(providerId: string): Promise<AuthProviderConfig>;
    getUser(uid: string): Promise<UserRecord>;
    getUserByEmail(email: string): Promise<UserRecord>;
    getUserByPhoneNumber(phoneNumber: string): Promise<UserRecord>;
    getUserByProviderUid(providerId: string, uid: string): Promise<UserRecord>;
    getUsers(identifiers: UserIdentifier[]): Promise<GetUsersResult>;
    importUsers(users: UserImportRecord[], options?: UserImportOptions): Promise<UserImportResult>;
    listProviderConfigs(options: AuthProviderConfigFilter): Promise<ListProviderConfigResults>;
    listUsers(maxResults?: number, pageToken?: string): Promise<ListUsersResult>;
    revokeRefreshTokens(uid: string): Promise<void>;
    setCustomUserClaims(uid: string, customUserClaims: object | null): Promise<void>;
    updateProviderConfig(providerId: string, updatedConfig: UpdateAuthProviderRequest): Promise<AuthProviderConfig>;
    updateUser(uid: string, properties: UpdateRequest): Promise<UserRecord>;
    // @alpha (undocumented)
    _verifyAuthBlockingToken(token: string, audience?: string): Promise<DecodedAuthBlockingToken>;
    verifyIdToken(idToken: string, checkRevoked?: boolean): Promise<DecodedIdToken>;
    verifySessionCookie(sessionCookie: string, checkRevoked?: boolean): Promise<DecodedIdToken>;
}

// @public
export interface BaseAuthProviderConfig {
    displayName?: string;
    enabled: boolean;
    providerId: string;
}

// @public
export interface BaseCreateMultiFactorInfoRequest {
    displayName?: string;
    factorId: string;
}

// @public
export interface BaseUpdateMultiFactorInfoRequest {
    displayName?: string;
    enrollmentTime?: string;
    factorId: string;
    uid?: string;
}

// @public
export type CreateMultiFactorInfoRequest = CreatePhoneMultiFactorInfoRequest;

// @public
export interface CreatePhoneMultiFactorInfoRequest extends BaseCreateMultiFactorInfoRequest {
    phoneNumber: string;
}

// @public
export interface CreateRequest extends UpdateRequest {
    multiFactor?: MultiFactorCreateSettings;
    uid?: string;
}

// @public
export type CreateTenantRequest = UpdateTenantRequest;

// @public
export interface CustomStrengthOptionsConfig {
    maxLength?: number;
    minLength?: number;
    requireLowercase?: boolean;
    requireNonAlphanumeric?: boolean;
    requireNumeric?: boolean;
    requireUppercase?: boolean;
}

// @alpha (undocumented)
export interface DecodedAuthBlockingToken {
    // (undocumented)
    [key: string]: any;
    // (undocumented)
    aud: string;
    // (undocumented)
    event_id: string;
    // (undocumented)
    event_type: string;
    // (undocumented)
    exp: number;
    // (undocumented)
    iat: number;
    // (undocumented)
    ip_address: string;
    // (undocumented)
    iss: string;
    // (undocumented)
    locale?: string;
    // (undocumented)
    oauth_access_token?: string;
    // (undocumented)
    oauth_expires_in?: number;
    // (undocumented)
    oauth_id_token?: string;
    // (undocumented)
    oauth_refresh_token?: string;
    // (undocumented)
    oauth_token_secret?: string;
    // (undocumented)
    raw_user_info?: string;
    // (undocumented)
    sign_in_attributes?: {
        [key: string]: any;
    };
    // (undocumented)
    sign_in_method?: string;
    // (undocumented)
    sub: string;
    // (undocumented)
    tenant_id?: string;
    // (undocumented)
    user_agent?: string;
    // Warning: (ae-forgotten-export) The symbol "DecodedAuthBlockingUserRecord" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    user_record?: DecodedAuthBlockingUserRecord;
}

// @public
export interface DecodedIdToken {
    [key: string]: any;
    aud: string;
    auth_time: number;
    email?: string;
    email_verified?: boolean;
    exp: number;
    firebase: {
        identities: {
            [key: string]: any;
        };
        sign_in_provider: string;
        sign_in_second_factor?: string;
        second_factor_identifier?: string;
        tenant?: string;
        [key: string]: any;
    };
    iat: number;
    iss: string;
    phone_number?: string;
    picture?: string;
    sub: string;
    uid: string;
}

// @public
export interface DeleteUsersResult {
    // Warning: (ae-forgotten-export) The symbol "FirebaseArrayIndexError" needs to be exported by the entry point index.d.ts
    errors: FirebaseArrayIndexError[];
    failureCount: number;
    successCount: number;
}

// @public
export interface EmailIdentifier {
    // (undocumented)
    email: string;
}

// @public
export interface EmailPrivacyConfig {
    enableImprovedEmailPrivacy?: boolean;
}

// @public
export interface EmailSignInProviderConfig {
    enabled: boolean;
    passwordRequired?: boolean;
}

// Warning: (ae-forgotten-export) The symbol "PrefixedFirebaseError" needs to be exported by the entry point index.d.ts
//
// @public
export class FirebaseAuthError extends PrefixedFirebaseError {
}

// @public
export function getAuth(app?: App): Auth;

// @public
export interface GetUsersResult {
    notFound: UserIdentifier[];
    users: UserRecord[];
}

// @public (undocumented)
export type HashAlgorithmType = 'SCRYPT' | 'STANDARD_SCRYPT' | 'HMAC_SHA512' | 'HMAC_SHA256' | 'HMAC_SHA1' | 'HMAC_MD5' | 'MD5' | 'PBKDF_SHA1' | 'BCRYPT' | 'PBKDF2_SHA256' | 'SHA512' | 'SHA256' | 'SHA1';

// @public
export interface ListProviderConfigResults {
    pageToken?: string;
    providerConfigs: AuthProviderConfig[];
}

// @public
export interface ListTenantsResult {
    pageToken?: string;
    tenants: Tenant[];
}

// @public
export interface ListUsersResult {
    pageToken?: string;
    users: UserRecord[];
}

// @public
export interface MultiFactorConfig {
    factorIds?: AuthFactorType[];
    providerConfigs?: MultiFactorProviderConfig[];
    state: MultiFactorConfigState;
}

// @public
export type MultiFactorConfigState = 'ENABLED' | 'DISABLED';

// @public
export interface MultiFactorCreateSettings {
    enrolledFactors: CreateMultiFactorInfoRequest[];
}

// @public
export abstract class MultiFactorInfo {
    readonly displayName?: string;
    readonly enrollmentTime?: string;
    readonly factorId: string;
    toJSON(): object;
    readonly uid: string;
}

// @public
export interface MultiFactorProviderConfig {
    state: MultiFactorConfigState;
    totpProviderConfig?: TotpMultiFactorProviderConfig;
}

// @public
export class MultiFactorSettings {
    enrolledFactors: MultiFactorInfo[];
    toJSON(): object;
}

// @public
export interface MultiFactorUpdateSettings {
    enrolledFactors: UpdateMultiFactorInfoRequest[] | null;
}

// @public
export interface OAuthResponseType {
    code?: boolean;
    idToken?: boolean;
}

// @public
export interface OIDCAuthProviderConfig extends BaseAuthProviderConfig {
    clientId: string;
    clientSecret?: string;
    issuer: string;
    responseType?: OAuthResponseType;
}

// @public
export interface OIDCUpdateAuthProviderRequest {
    clientId?: string;
    clientSecret?: string;
    displayName?: string;
    enabled?: boolean;
    issuer?: string;
    responseType?: OAuthResponseType;
}

// @public
export interface PasswordPolicyConfig {
    constraints?: CustomStrengthOptionsConfig;
    enforcementState?: PasswordPolicyEnforcementState;
    forceUpgradeOnSignin?: boolean;
}

// @public
export type PasswordPolicyEnforcementState = 'ENFORCE' | 'OFF';

// @public
export interface PhoneIdentifier {
    // (undocumented)
    phoneNumber: string;
}

// @public
export class PhoneMultiFactorInfo extends MultiFactorInfo {
    readonly phoneNumber: string;
    toJSON(): object;
}

// @public
export class ProjectConfig {
    readonly emailPrivacyConfig?: EmailPrivacyConfig;
    get multiFactorConfig(): MultiFactorConfig | undefined;
    readonly passwordPolicyConfig?: PasswordPolicyConfig;
    get recaptchaConfig(): RecaptchaConfig | undefined;
    readonly smsRegionConfig?: SmsRegionConfig;
    toJSON(): object;
}

// @public
export class ProjectConfigManager {
    getProjectConfig(): Promise<ProjectConfig>;
    updateProjectConfig(projectConfigOptions: UpdateProjectConfigRequest): Promise<ProjectConfig>;
}

// @public
export interface ProviderIdentifier {
    // (undocumented)
    providerId: string;
    // (undocumented)
    providerUid: string;
}

// @public
export type RecaptchaAction = 'BLOCK';

// @public
export interface RecaptchaConfig {
    emailPasswordEnforcementState?: RecaptchaProviderEnforcementState;
    managedRules?: RecaptchaManagedRule[];
    recaptchaKeys?: RecaptchaKey[];
    useAccountDefender?: boolean;
}

// @public
export interface RecaptchaKey {
    key: string;
    type?: RecaptchaKeyClientType;
}

// @public
export type RecaptchaKeyClientType = 'WEB' | 'IOS' | 'ANDROID';

// @public
export interface RecaptchaManagedRule {
    action?: RecaptchaAction;
    endScore: number;
}

// @public
export type RecaptchaProviderEnforcementState = 'OFF' | 'AUDIT' | 'ENFORCE';

// @public
export interface SAMLAuthProviderConfig extends BaseAuthProviderConfig {
    callbackURL?: string;
    idpEntityId: string;
    rpEntityId: string;
    ssoURL: string;
    x509Certificates: string[];
}

// @public
export interface SAMLUpdateAuthProviderRequest {
    callbackURL?: string;
    displayName?: string;
    enabled?: boolean;
    idpEntityId?: string;
    rpEntityId?: string;
    ssoURL?: string;
    x509Certificates?: string[];
}

// @public
export interface SessionCookieOptions {
    expiresIn: number;
}

// @public
export type SmsRegionConfig = AllowByDefaultWrap | AllowlistOnlyWrap;

// @public
export class Tenant {
    // (undocumented)
    readonly anonymousSignInEnabled: boolean;
    readonly displayName?: string;
    readonly emailPrivacyConfig?: EmailPrivacyConfig;
    get emailSignInConfig(): EmailSignInProviderConfig | undefined;
    get multiFactorConfig(): MultiFactorConfig | undefined;
    readonly passwordPolicyConfig?: PasswordPolicyConfig;
    get recaptchaConfig(): RecaptchaConfig | undefined;
    readonly smsRegionConfig?: SmsRegionConfig;
    readonly tenantId: string;
    readonly testPhoneNumbers?: {
        [phoneNumber: string]: string;
    };
    toJSON(): object;
}

// @public
export class TenantAwareAuth extends BaseAuth {
    createSessionCookie(idToken: string, sessionCookieOptions: SessionCookieOptions): Promise<string>;
    readonly tenantId: string;
    verifyIdToken(idToken: string, checkRevoked?: boolean): Promise<DecodedIdToken>;
    verifySessionCookie(sessionCookie: string, checkRevoked?: boolean): Promise<DecodedIdToken>;
}

// @public
export class TenantManager {
    authForTenant(tenantId: string): TenantAwareAuth;
    createTenant(tenantOptions: CreateTenantRequest): Promise<Tenant>;
    deleteTenant(tenantId: string): Promise<void>;
    getTenant(tenantId: string): Promise<Tenant>;
    listTenants(maxResults?: number, pageToken?: string): Promise<ListTenantsResult>;
    updateTenant(tenantId: string, tenantOptions: UpdateTenantRequest): Promise<Tenant>;
}

// @public
export interface TotpMultiFactorProviderConfig {
    adjacentIntervals?: number;
}

// @public
export interface UidIdentifier {
    // (undocumented)
    uid: string;
}

// @public (undocumented)
export type UpdateAuthProviderRequest = SAMLUpdateAuthProviderRequest | OIDCUpdateAuthProviderRequest;

// @public
export type UpdateMultiFactorInfoRequest = UpdatePhoneMultiFactorInfoRequest;

// @public
export interface UpdatePhoneMultiFactorInfoRequest extends BaseUpdateMultiFactorInfoRequest {
    phoneNumber: string;
}

// @public
export interface UpdateProjectConfigRequest {
    emailPrivacyConfig?: EmailPrivacyConfig;
    multiFactorConfig?: MultiFactorConfig;
    passwordPolicyConfig?: PasswordPolicyConfig;
    recaptchaConfig?: RecaptchaConfig;
    smsRegionConfig?: SmsRegionConfig;
}

// @public
export interface UpdateRequest {
    disabled?: boolean;
    displayName?: string | null;
    email?: string;
    emailVerified?: boolean;
    multiFactor?: MultiFactorUpdateSettings;
    password?: string;
    phoneNumber?: string | null;
    photoURL?: string | null;
    providersToUnlink?: string[];
    providerToLink?: UserProvider;
}

// @public
export interface UpdateTenantRequest {
    anonymousSignInEnabled?: boolean;
    displayName?: string;
    emailPrivacyConfig?: EmailPrivacyConfig;
    emailSignInConfig?: EmailSignInProviderConfig;
    multiFactorConfig?: MultiFactorConfig;
    passwordPolicyConfig?: PasswordPolicyConfig;
    recaptchaConfig?: RecaptchaConfig;
    smsRegionConfig?: SmsRegionConfig;
    testPhoneNumbers?: {
        [phoneNumber: string]: string;
    } | null;
}

// @public
export type UserIdentifier = UidIdentifier | EmailIdentifier | PhoneIdentifier | ProviderIdentifier;

// @public
export interface UserImportOptions {
    hash: {
        algorithm: HashAlgorithmType;
        key?: Buffer;
        saltSeparator?: Buffer;
        rounds?: number;
        memoryCost?: number;
        parallelization?: number;
        blockSize?: number;
        derivedKeyLength?: number;
    };
}

// @public
export interface UserImportRecord {
    customClaims?: {
        [key: string]: any;
    };
    disabled?: boolean;
    displayName?: string;
    email?: string;
    emailVerified?: boolean;
    metadata?: UserMetadataRequest;
    multiFactor?: MultiFactorUpdateSettings;
    passwordHash?: Buffer;
    passwordSalt?: Buffer;
    phoneNumber?: string;
    photoURL?: string;
    providerData?: UserProviderRequest[];
    tenantId?: string;
    uid: string;
}

// @public
export interface UserImportResult {
    errors: FirebaseArrayIndexError[];
    failureCount: number;
    successCount: number;
}

// @public
export class UserInfo {
    readonly displayName: string;
    readonly email: string;
    readonly phoneNumber: string;
    readonly photoURL: string;
    readonly providerId: string;
    toJSON(): object;
    readonly uid: string;
}

// @public
export class UserMetadata {
    readonly creationTime: string;
    readonly lastRefreshTime?: string | null;
    readonly lastSignInTime: string;
    toJSON(): object;
}

// @public
export interface UserMetadataRequest {
    creationTime?: string;
    lastSignInTime?: string;
}

// @public
export interface UserProvider {
    displayName?: string;
    email?: string;
    phoneNumber?: string;
    photoURL?: string;
    providerId?: string;
    uid?: string;
}

// @public
export interface UserProviderRequest {
    displayName?: string;
    email?: string;
    phoneNumber?: string;
    photoURL?: string;
    providerId: string;
    uid: string;
}

// @public
export class UserRecord {
    readonly customClaims?: {
        [key: string]: any;
    };
    readonly disabled: boolean;
    readonly displayName?: string;
    readonly email?: string;
    readonly emailVerified: boolean;
    readonly metadata: UserMetadata;
    readonly multiFactor?: MultiFactorSettings;
    readonly passwordHash?: string;
    readonly passwordSalt?: string;
    readonly phoneNumber?: string;
    readonly photoURL?: string;
    readonly providerData: UserInfo[];
    readonly tenantId?: string | null;
    toJSON(): object;
    readonly tokensValidAfterTime?: string;
    readonly uid: string;
}

```
