## API Report File for "firebase-admin.machine-learning"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

/// <reference types="node" />

import { Agent } from 'http';

// @public (undocumented)
export interface GcsTfliteModelOptions extends ModelOptionsBase {
    // (undocumented)
    tfliteModel: {
        gcsTfliteUri: string;
    };
}

// Warning: (ae-forgotten-export) The symbol "App" needs to be exported by the entry point index.d.ts
//
// @public
export function getMachineLearning(app?: App): MachineLearning;

// @public
export interface ListModelsOptions {
    filter?: string;
    pageSize?: number;
    pageToken?: string;
}

// @public
export interface ListModelsResult {
    readonly models: Model[];
    readonly pageToken?: string;
}

// @public
export class MachineLearning {
    get app(): App;
    createModel(model: ModelOptions): Promise<Model>;
    deleteModel(modelId: string): Promise<void>;
    getModel(modelId: string): Promise<Model>;
    listModels(options?: ListModelsOptions): Promise<ListModelsResult>;
    publishModel(modelId: string): Promise<Model>;
    unpublishModel(modelId: string): Promise<Model>;
    updateModel(modelId: string, model: ModelOptions): Promise<Model>;
}

// @public
export class Model {
    get createTime(): string;
    get displayName(): string;
    get etag(): string;
    get locked(): boolean;
    get modelHash(): string | undefined;
    get modelId(): string;
    get published(): boolean;
    get tags(): string[];
    get tfliteModel(): TFLiteModel | undefined;
    toJSON(): {
        [key: string]: any;
    };
    get updateTime(): string;
    get validationError(): string | undefined;
    waitForUnlocked(maxTimeMillis?: number): Promise<void>;
}

// @public (undocumented)
export type ModelOptions = ModelOptionsBase | GcsTfliteModelOptions;

// @public
export interface ModelOptionsBase {
    // (undocumented)
    displayName?: string;
    // (undocumented)
    tags?: string[];
}

// @public
export interface TFLiteModel {
    readonly gcsTfliteUri?: string;
    readonly sizeBytes: number;
}

```
