## API Report File for "firebase-admin.project-management"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

/// <reference types="node" />

import { Agent } from 'http';

// @public
export class AndroidApp {
    addShaCertificate(certificateToAdd: ShaCertificate): Promise<void>;
    // (undocumented)
    readonly appId: string;
    deleteShaCertificate(certificateToDelete: ShaCertificate): Promise<void>;
    getConfig(): Promise<string>;
    getMetadata(): Promise<AndroidAppMetadata>;
    getShaCertificates(): Promise<ShaCertificate[]>;
    setDisplayName(newDisplayName: string): Promise<void>;
}

// @public
export interface AndroidAppMetadata extends AppMetadata {
    packageName: string;
    // (undocumented)
    platform: AppPlatform.ANDROID;
}

// @public
export interface AppMetadata {
    appId: string;
    displayName?: string;
    platform: AppPlatform;
    projectId: string;
    resourceName: string;
}

// @public
export enum AppPlatform {
    ANDROID = "ANDROID",
    IOS = "IOS",
    PLATFORM_UNKNOWN = "PLATFORM_UNKNOWN"
}

// Warning: (ae-forgotten-export) The symbol "PrefixedFirebaseError" needs to be exported by the entry point index.d.ts
//
// @public
export class FirebaseProjectManagementError extends PrefixedFirebaseError {
}

// Warning: (ae-forgotten-export) The symbol "App" needs to be exported by the entry point index.d.ts
//
// @public
export function getProjectManagement(app?: App): ProjectManagement;

// @public
export class IosApp {
    // (undocumented)
    readonly appId: string;
    getConfig(): Promise<string>;
    getMetadata(): Promise<IosAppMetadata>;
    setDisplayName(newDisplayName: string): Promise<void>;
}

// @public
export interface IosAppMetadata extends AppMetadata {
    bundleId: string;
    // (undocumented)
    platform: AppPlatform.IOS;
}

// @public
export class ProjectManagement {
    androidApp(appId: string): AndroidApp;
    // (undocumented)
    readonly app: App;
    createAndroidApp(packageName: string, displayName?: string): Promise<AndroidApp>;
    createIosApp(bundleId: string, displayName?: string): Promise<IosApp>;
    iosApp(appId: string): IosApp;
    listAndroidApps(): Promise<AndroidApp[]>;
    listAppMetadata(): Promise<AppMetadata[]>;
    listIosApps(): Promise<IosApp[]>;
    setDisplayName(newDisplayName: string): Promise<void>;
    shaCertificate(shaHash: string): ShaCertificate;
}

// @public (undocumented)
export type ProjectManagementErrorCode = 'already-exists' | 'authentication-error' | 'internal-error' | 'invalid-argument' | 'invalid-project-id' | 'invalid-server-response' | 'not-found' | 'service-unavailable' | 'unknown-error';

// @public
export class ShaCertificate {
    readonly certType: ('sha1' | 'sha256');
    // (undocumented)
    readonly resourceName?: string | undefined;
    // (undocumented)
    readonly shaHash: string;
}

```
